unit Unit1;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Kohdelistat: TListBox;
    Poistettavatkuvat: TListBox;
    Button1: TButton;
    Button2: TButton;
    edistys: TProgressBar;
    Label1: TLabel;
    Button3: TButton;
    Button4: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  end;

var
  Form1: TForm1;
  exedir, path, path2: string;
  kuvat: array of string;

implementation

{$R *.dfm}

function LoadList(fname: string): string;
var itemtext: TStringlist;
begin
 result:='';
 if fileexists(fname) then
 begin
  itemtext:=TStringlist.Create;
  try
   itemtext.LoadFromFile(fname);
   result:=itemtext.text;
  finally
   itemtext.Free;
  end;
 end;
end;

procedure etsi_tiedostot2(path: string);
var intFound: integer;
    SearchRec: TSearchRec;
begin
 setlength(kuvat, 0);
 intFound:=FindFirst(path, faAnyFile, SearchRec);
 while intFound=0 do
 begin
  setlength(kuvat, length(kuvat)+1);
  kuvat[length(kuvat)-1]:=SearchRec.Name;
  intFound:=FindNext(SearchRec);
 end;
 FindClose(SearchRec);
end;

procedure etsi_tiedostot(path: string);
var intFound: integer;
    SearchRec: TSearchRec;
begin
 intFound:=FindFirst(path, faAnyFile, SearchRec);
 while intFound=0 do
 begin
  form1.Kohdelistat.Items.add(SearchRec.Name);
  intFound:=FindNext(SearchRec);
 end;
 FindClose(SearchRec);
end;

function loytyyko_kansio(d: string): boolean;
begin
 result:=DirectoryExists(d);
 if not result then showmessage('Kansiota ei lytynyt:'#13#10#13#10+d);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 exedir:=stringreplace(ExtractFilePath(ParamStr(0)), '/', '\', [rfreplaceall]);
 path:=exedir+'kohdelistat\';
 path2:=exedir+'ilmoitustenkuvat\';
 if loytyyko_kansio(path)=false then exit;
 if loytyyko_kansio(path2)=false then exit;
 Kohdelistat.Items.Clear;
 etsi_tiedostot(path+'*.hni');
 etsi_tiedostot(path+'*.hnl');
 etsi_tiedostot(path+'*.csv');
 if Kohdelistat.Items.count>0 then
  Button1.Enabled:=true
 else
  showmessage('Kohdelistoja ei lytynyt!');
end;

procedure TForm1.Button1Click(Sender: TObject);
var i, j, p, m: integer;
    s: string;
begin
 button1.Enabled:=false;
 etsi_tiedostot2(path2+'*.jpg');

 m:=Kohdelistat.items.count*length(Kuvat);
 p:=0;
 for i:=0 to Kohdelistat.items.count-1 do
 begin
  s:=LoadList(path+Kohdelistat.Items.strings[i]);
  for j:=length(Kuvat)-1 downto 0 do
  begin
   p:=p+1;
   if ansipos(Kuvat[j], s)>0 then Kuvat[j]:='';
   edistys.Position:=round(p/m*100);
   application.processmessages;
  end;
 end;

 Poistettavatkuvat.Items.Clear;
 for j:=0 to length(kuvat)-1 do
  if Kuvat[j]<>'' then
   Poistettavatkuvat.items.Add(Kuvat[j]);
 Label1.Caption:='Kyttmttmi lytyi: '+inttostr(Poistettavatkuvat.items.count);
 if Poistettavatkuvat.items.count>0 then
 begin
  Button2.Enabled:=true;
  Button3.Enabled:=true;
 end;
 button1.Enabled:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);
var j: integer;
begin
 for j:=Poistettavatkuvat.Items.Count-1 downto 0 do
 begin
  if not Deletefile(path2+Poistettavatkuvat.Items.strings[j]) then
  begin
   showmessage('Ei voitu poistaa: '+path2+Poistettavatkuvat.Items.strings[j]);
   exit;
  end;
  Poistettavatkuvat.Items.Delete(j);
 end;
 Button2.Enabled:=false;
 Button3.Enabled:=false;
end;

procedure TForm1.Button3Click(Sender: TObject);
var j: integer;
    d: string;
begin
 d:=exedir+'roskat\';
 if not DirectoryExists(d) then
  if not Createdir(d) then
  begin
   showmessage('Kansion "roskat" luominen ei onnistunut!');
   exit;
  end;
 for j:=Poistettavatkuvat.Items.Count-1 downto 0 do
 begin
  if not MovefileEx(pchar(path2+Poistettavatkuvat.Items.strings[j]), pchar(d+Poistettavatkuvat.Items.strings[j]), MOVEFILE_REPLACE_EXISTING) then
  begin
   showmessage('Ei voitu siirt: '+path2+Poistettavatkuvat.Items.strings[j]);
   exit;
  end;
  Poistettavatkuvat.Items.Delete(j);
 end;
 Button2.Enabled:=false;
 Button3.Enabled:=false;
end;

procedure TForm1.Button4Click(Sender: TObject);
var s: string;
begin
 s:='Versio 1.00'#13#13'Mahdollistaa tarpeettomien kuvien siivoamisen'#13'HNilmoittajan "ilmoitustenkuvat" kansiosta.'#13#13;
 s:=s+'- Laita HNilmoittajan kanssa samaan kansioon.'#13#13'- Listat tulee olla "kohdelistat" kansiossa.'#13#13;
 s:=s+'- Kuvat tulee olla "ilmoitustenkuvat" kansiossa.'#13#13;
 s:=s+'Nytt kuvat, joita ei kytet listoissa.'#13;
 showmessage(s);
end;

end.
